#include "element.h"
#include <stdlib.h>
#include <stdio.h>

void init_integer (element* e1, element e2)
{
  // Reservation de l'emplacement
  *e1 = malloc(sizeof(int));
  // Copie de e2 vers e1
  *((int *)(*e1)) = *(int *)e2;
}

void destroy_integer(element e1)
{
  free(e1);
}

// Why generic ? Because we can do this ! Modify only one value to change an entire container.
// Possible value : _vector, _list
#define _vector 1

#ifdef _vector
#include "vector.h"
#define create_container create_vector
typedef vector container;
#elif _list
#include "list.h"
#define create_container create_list
typedef list container;
#endif

int main( int argc, char* argv[])
{
  container* c = create_container(init_integer, destroy_integer);
  for(int i=0; i < 100; ++i)
    c->push_back(c, &i);

  printf("size : %lu\n", c->size(c));

  for(int i=0; i < 50; ++i)
    c->pop_back(c);

  container* c2 = c->clone(c);
  
  c->clear(c);
  printf("size : %lu and empty : %s \n", c->size(c), (c->empty(c) ? "yes":"no"));

  printf("25th element : %d\n", (*(int*) c2->at(c2, 25)) );

  c2->assign(c, c2);
														
  c->destroy(c);
  free(c);

  int i = 800;
  c2->insert(c2, &i, 10);
  (*(int*) c2->front(c2)) = 1000;
  (*(int*) c2->back(c2)) = 1000;

  c2->destroy(c2);
  free(c2);

  exit(EXIT_SUCCESS);
}
